<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "twilio_number".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "TwilioNumber".
 *
 * Columns in table "twilio_number" available as properties of the model,
 * followed by relations of table "twilio_number" available as properties of the model.
 *
 * @property string $id
 * @property string $provider_id
 * @property integer $practice_id
 * @property string $twilio_partner_id
 * @property string $twilio_number
 * @property integer $enabled
 * @property integer $is_dynamic
 * @property string $redirect_to
 * @property string $redirect_created
 * @property string $intro_greeting_message
 * @property integer $enabled_interface
 * @property integer $enabled_recording
 * @property integer $enabled_email
 * @property string $date_added
 * @property string $date_delete_on
 * @property string $date_force_delete_on
 *
 * @property AnalyticsEvent[] $analyticsEvents
 * @property TwilioPartner $twilioPartner
 * @property Practice $practice
 * @property Provider $provider
 *
 * @property string $account
 *
 */
abstract class BaseTwilioNumber extends BaseModel
{

    public $account;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'twilio_number';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Twilio Number|Twilio Numbers', $n);
    }

    public static function representingColumn()
    {
        return 'twilio_number';
    }

    public function rules()
    {
        return array(
            array('practice_id, twilio_partner_id', 'required'),
            array('enabled, enabled_interface, enabled_recording, is_dynamic', 'numerical', 'integerOnly' => true),
            array('provider_id, practice_id, twilio_partner_id', 'length', 'max' => 11),
            array('twilio_number', 'length', 'max' => 10),
            array('redirect_to', 'length', 'max' => 12),
            array('intro_greeting_message', 'length', 'max' => 255),
            array('redirect_created, date_delete_on, date_force_delete_on', 'safe'),
            array('provider_id, twilio_number, enabled, redirect_to, redirect_created, intro_greeting_message, enabled_interface, enabled_recording, enabled_email, is_dynamic, date_added, date_delete_on, date_force_delete_on, forced_valid', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, practice_id, twilio_partner_id, twilio_number, enabled, redirect_to, redirect_created, intro_greeting_message, enabled_interface, enabled_recording, account, is_dynamic, date_added, date_force_delete_on, forced_valid', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'analyticsEvents' => array(self::HAS_MANY, 'AnalyticsEvent', 'twilio_number_id'),
            'twilioPartner' => array(self::BELONGS_TO, 'TwilioPartner', 'twilio_partner_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id')
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account' => Yii::t('app', 'Account'),
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Practice'),
            'twilio_partner_id' => Yii::t('app', 'Partner'),
            'twilio_number' => Yii::t('app', 'Number'),
            'enabled' => Yii::t('app', 'Enabled'),
            'is_dynamic' => Yii::t('app', 'Is 1-time use'),
            'redirect_to' => Yii::t('app', 'Redirect To'),
            'redirect_created' => Yii::t('app', 'Redirect Created'),
            'intro_greeting_message' => Yii::t('app', 'Intro Greeting Message'),
            'enabled_interface' => Yii::t('app', 'Interface'),
            'enabled_recording' => Yii::t('app', 'Recording'),
            'enabled_email' => Yii::t('app', 'Email'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_delete_on' => Yii::t('app', 'Date Delete On'),
            'date_force_delete_on' => Yii::t('app', 'Date Force Delete On'),
            'forced_valid' => Yii::t('app', 'Forced Valid'),
            'analyticsEvents' => null,
            'twilioPartner' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        /**
         * all of the numbers in twilio are linked by practice but not all of them are linked by provider
         * (only 44 out of 1400) so we better link by account_practice instead of account_provider
         */
        $criteria->join .= ' LEFT JOIN account_practice ap ON ap.practice_id = t.practice_id';
        $criteria->join .= ' LEFT JOIN account ON account.id = ap.account_id';
        $criteria->join .= ' LEFT JOIN practice ON practice.id = t.practice_id';
        $criteria->join .= ' LEFT JOIN provider ON provider.id = t.provider_id';
        $criteria->select = 't.*';

        $criteria->addSearchCondition('CONCAT(account.first_name," ",account.last_name)', $this->account);

        $criteria->compare('intro_greeting_message', $this->intro_greeting_message, true);
        $criteria->compare('enabled_interface', $this->enabled_interface);
        $criteria->compare('enabled_recording', $this->enabled_recording);
        $criteria->compare('enabled_email', $this->enabled_email);
        $criteria->compare('date_force_delete_on', $this->date_force_delete_on, true);

        // it will search by id or provider.first_last
        if (!empty($this->provider_id)) {
            if (is_numeric($this->provider_id)) {
                $criteria->compare('t.provider_id', $this->provider_id);
            } else {
                $criteria->addSearchCondition("provider.first_last", $this->provider_id);
            }
        }

        // it will search by id or practice.name
        if (!empty($this->practice_id)) {
            if (is_numeric($this->practice_id)) {
                $criteria->compare('t.practice_id', $this->practice_id);
            } else {
                $criteria->addSearchCondition("practice.name", $this->practice_id);
            }
        }

        $criteria->compare('twilio_partner_id', $this->twilio_partner_id);
        $criteria->compare('twilio_number', $this->twilio_number, true);
        $criteria->compare('t.enabled', $this->enabled);
        $criteria->compare('redirect_to', $this->redirect_to, true);
        $criteria->compare('redirect_created', $this->redirect_created, true);
        $criteria->compare('is_dynamic', $this->is_dynamic);
        $criteria->compare('date_added', $this->date_added);

        $criteria->group = 'twilio_number';

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

}
